//--------------------------------------------------------
//	DemoMessageFilter.cpp
//	We are not liable for anything involving this software
//	including but not limited to damage or harm to your
//	software, hardware, mind, body or soul.
//		Written by Bill Morris
//		Memetic Corporation
//		bmorris@memetic.com
//		http://www.memetic.com
//	Hacked from HelloWorld
//		Copyright 1995 Be Incorporated, All Rights Reserved.
//--------------------------------------------------------

#ifndef _MESSAGE_FILTER_H
#include <MessageFilter.h>
#endif

#ifndef _VIEW_H
#include <View.h>
#endif

#ifndef DEMO_MESSAGE_FILTER_H
#include "DemoMessageFilter.h"
#endif

DemoMessageFilter::DemoMessageFilter(message_delivery delivery,message_source source) : BMessageFilter(delivery,source)
{
	//	ignore first B_MOUSE_UP event on first click
	mouse_status = false;
}

filter_result DemoMessageFilter::Filter(BMessage *message, BHandler **target) 
{
	// NOTE: This Filter should _ONLY_ be used with BView objects
	BView *view = (BView *)*target;

	//	print all messages to stdio if you want to...
	//	message->PrintToStream();

	switch(message->what) {
		case B_MOUSE_DOWN:
			//	not first click so we dont ignore B_MOUSE_UP
			mouse_status = true;
			//	MAGICK!!
			//		we got a mouse down message so lets pass it
			//		to the BView that instanced this filter
			view->MouseDown(message->FindPoint("where"));
			//	skip this message because we handed it off
			return B_SKIP_MESSAGE;
			break;
		case B_MOUSE_UP:
			//	if not first click dont ignore B_MOUSE_UP
			if (mouse_status == true) {
				//	MAGICK!!
				//		we got a mouse up message so lets pass it
				//		to the BView that instanced this filter
				view->MouseUp(message->FindPoint("where"));
				//	reset mouse status
				mouse_status = false;
			}
			//	skip this message because we handed it off
			return B_SKIP_MESSAGE;
			break;
		default:
			//	dispatch this message because we have no clue
			//	or dont care what it is...
			return B_DISPATCH_MESSAGE;
			break;
	}
}

